<html>
<head>
<title>OgreSkeleton.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreSkeleton.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreSkeleton_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __Skeleton_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __Skeleton_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreResource_8h.html">OgreResource.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreQuaternion_8h.html">OgreQuaternion.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreStringVector_8h.html">OgreStringVector.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="OgreAnimation_8h.html">OgreAnimation.h</a>&quot;</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">namespace </span>Ogre {
<a name="l00049"></a><a class="code" href="group__Animation.html#ga230b218164ffe5e6ee8970bef57e6abd">00049</a>     <span class="keyword">enum</span> <a class="code" href="group__Animation.html#ga230b218164ffe5e6ee8970bef57e6abd">SkeletonAnimationBlendMode</a> {
<a name="l00051"></a><a class="code" href="group__Animation.html#gga230b218164ffe5e6ee8970bef57e6abda4d13dab20a3642f5fc20cf2bec22c2c3">00051</a>         <a class="code" href="group__Animation.html#gga230b218164ffe5e6ee8970bef57e6abda4d13dab20a3642f5fc20cf2bec22c2c3" title="Animations are applied by calculating a weighted average of all animations.">ANIMBLEND_AVERAGE</a> = 0,
<a name="l00053"></a><a class="code" href="group__Animation.html#gga230b218164ffe5e6ee8970bef57e6abda5628f84206e4555c948422d2e62b7793">00053</a>         <a class="code" href="group__Animation.html#gga230b218164ffe5e6ee8970bef57e6abda5628f84206e4555c948422d2e62b7793" title="Animations are applied by calculating a weighted cumulative total.">ANIMBLEND_CUMULATIVE</a> = 1
<a name="l00054"></a>00054     };
<a name="l00055"></a>00055 
<a name="l00056"></a><a class="code" href="group__Animation.html#ga4393e2afffe021cb323b896779de3d17">00056</a> <span class="preprocessor">#define OGRE_MAX_NUM_BONES 256</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span>
<a name="l00058"></a>00058     
<a name="l00059"></a>00059     <span class="keyword">struct </span>LinkedSkeletonAnimationSource;
<a name="l00060"></a>00060 
<a name="l00086"></a><a class="code" href="classOgre_1_1Skeleton.html">00086</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1AnimationContainer.html" title="An animation container interface, which allows generic access to sibling animations.">AnimationContainer</a>
<a name="l00087"></a>00087     {
<a name="l00088"></a><a class="code" href="classOgre_1_1Skeleton.html#a091f8c455d475a25c676a71ba577fa07">00088</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1SkeletonInstance.html" title="A SkeletonInstance is a single instance of a Skeleton used by a world object.">SkeletonInstance</a>;
<a name="l00089"></a>00089     <span class="keyword">protected</span>:
<a name="l00091"></a>00091         <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>();
<a name="l00092"></a>00092 
<a name="l00093"></a>00093     <span class="keyword">public</span>:
<a name="l00099"></a>00099         <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00100"></a>00100             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual = <span class="keyword">false</span>, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader = 0);
<a name="l00101"></a>00101         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>();
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00117"></a>00117         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* createBone(<span class="keywordtype">void</span>);
<a name="l00118"></a>00118 
<a name="l00132"></a>00132         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* createBone(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle);
<a name="l00133"></a>00133 
<a name="l00147"></a>00147         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* createBone(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00148"></a>00148 
<a name="l00159"></a>00159         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* createBone(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle);
<a name="l00160"></a>00160 
<a name="l00162"></a>00162         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNumBones(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00163"></a>00163 
<a name="l00175"></a>00175         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* getRootBone(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00176"></a>00176 
<a name="l00177"></a><a class="code" href="classOgre_1_1Skeleton.html#a7b773aab734f2f517897931dcb84a1e8">00177</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Bone*&gt;::type</a> <a class="code" href="classOgre_1_1Skeleton.html#a7b773aab734f2f517897931dcb84a1e8">BoneList</a>;
<a name="l00178"></a><a class="code" href="classOgre_1_1Skeleton.html#a9174ebaa5262a5aee4dff1978bb80412">00178</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">VectorIterator&lt;BoneList&gt;</a> <a class="code" href="classOgre_1_1Skeleton.html#a9174ebaa5262a5aee4dff1978bb80412">BoneIterator</a>;
<a name="l00180"></a>00180         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">BoneIterator</a> getRootBoneIterator(<span class="keywordtype">void</span>);
<a name="l00182"></a>00182         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">BoneIterator</a> getBoneIterator(<span class="keywordtype">void</span>);
<a name="l00183"></a>00183 
<a name="l00185"></a>00185         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* getBone(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle) <span class="keyword">const</span>;
<a name="l00186"></a>00186 
<a name="l00188"></a>00188         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* getBone(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name) <span class="keyword">const</span>;
<a name="l00189"></a>00189 
<a name="l00191"></a>00191         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> hasBone(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name) <span class="keyword">const</span>;
<a name="l00192"></a>00192 
<a name="l00196"></a>00196         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setBindingPose(<span class="keywordtype">void</span>);
<a name="l00197"></a>00197 
<a name="l00207"></a>00207         <span class="keyword">virtual</span> <span class="keywordtype">void</span> reset(<span class="keywordtype">bool</span> resetManualBones = <span class="keyword">false</span>);
<a name="l00208"></a>00208 
<a name="l00213"></a>00213         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* createAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> length);
<a name="l00214"></a>00214 
<a name="l00223"></a>00223         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* getAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00224"></a>00224             <span class="keyword">const</span> <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html" title="Link to another skeleton to share animations.">LinkedSkeletonAnimationSource</a>** linker) <span class="keyword">const</span>;
<a name="l00225"></a>00225 
<a name="l00232"></a>00232         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* getAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name) <span class="keyword">const</span>;
<a name="l00233"></a>00233 
<a name="l00235"></a>00235         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* _getAnimationImpl(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00236"></a>00236             <span class="keyword">const</span> <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html" title="Link to another skeleton to share animations.">LinkedSkeletonAnimationSource</a>** linker = 0) <span class="keyword">const</span>;
<a name="l00237"></a>00237 
<a name="l00238"></a>00238 
<a name="l00240"></a>00240         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> hasAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name) <span class="keyword">const</span>;
<a name="l00241"></a>00241 
<a name="l00243"></a>00243         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00244"></a>00244 
<a name="l00256"></a>00256         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setAnimationState(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AnimationStateSet.html" title="Class encapsulating a set of AnimationState objects.">AnimationStateSet</a>&amp; animSet);
<a name="l00257"></a>00257 
<a name="l00258"></a>00258 
<a name="l00263"></a>00263         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _initAnimationState(<a class="code" href="classOgre_1_1AnimationStateSet.html" title="Class encapsulating a set of AnimationState objects.">AnimationStateSet</a>* animSet);
<a name="l00264"></a>00264 
<a name="l00269"></a>00269         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _refreshAnimationState(<a class="code" href="classOgre_1_1AnimationStateSet.html" title="Class encapsulating a set of AnimationState objects.">AnimationStateSet</a>* animSet);
<a name="l00270"></a>00270 
<a name="l00277"></a>00277         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _getBoneMatrices(<a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>* pMatrices);
<a name="l00278"></a>00278 
<a name="l00280"></a>00280         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNumAnimations(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00281"></a>00281 
<a name="l00287"></a>00287         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* getAnimation(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index) <span class="keyword">const</span>;
<a name="l00288"></a>00288 
<a name="l00289"></a>00289 
<a name="l00291"></a>00291         <span class="keyword">virtual</span> <a class="code" href="group__Animation.html#ga230b218164ffe5e6ee8970bef57e6abd">SkeletonAnimationBlendMode</a> getBlendMode() <span class="keyword">const</span>;
<a name="l00293"></a>00293         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setBlendMode(<a class="code" href="group__Animation.html#ga230b218164ffe5e6ee8970bef57e6abd">SkeletonAnimationBlendMode</a> state);
<a name="l00294"></a>00294 
<a name="l00296"></a>00296         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _updateTransforms(<span class="keywordtype">void</span>);
<a name="l00297"></a>00297 
<a name="l00303"></a>00303         <span class="keyword">virtual</span> <span class="keywordtype">void</span> optimiseAllAnimations(<span class="keywordtype">bool</span> preservingIdentityNodeTracks = <span class="keyword">false</span>);
<a name="l00304"></a>00304 
<a name="l00338"></a>00338         <span class="keyword">virtual</span> <span class="keywordtype">void</span> addLinkedSkeletonAnimationSource(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; skelName, 
<a name="l00339"></a>00339             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scale = 1.0f);
<a name="l00341"></a>00341         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeAllLinkedSkeletonAnimationSources(<span class="keywordtype">void</span>);
<a name="l00342"></a>00342         
<a name="l00343"></a>00343         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;LinkedSkeletonAnimationSource&gt;::type</a> 
<a name="l00344"></a><a class="code" href="classOgre_1_1Skeleton.html#ac2559ddaccbf43ffc97330573c9561fd">00344</a>             <a class="code" href="classOgre_1_1Skeleton.html#ac2559ddaccbf43ffc97330573c9561fd">LinkedSkeletonAnimSourceList</a>;
<a name="l00345"></a>00345         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Concrete IteratorWrapper for const access to the underlying container.">ConstVectorIterator&lt;LinkedSkeletonAnimSourceList&gt;</a> 
<a name="l00346"></a><a class="code" href="classOgre_1_1Skeleton.html#ae93aeeef114b2c5d9db170d0beda944b">00346</a>             <a class="code" href="classOgre_1_1Skeleton.html#ae93aeeef114b2c5d9db170d0beda944b">LinkedSkeletonAnimSourceIterator</a>;
<a name="l00348"></a>00348         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Concrete IteratorWrapper for const access to the underlying container.">LinkedSkeletonAnimSourceIterator</a> 
<a name="l00349"></a>00349             getLinkedSkeletonAnimationSourceIterator(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00350"></a>00350 
<a name="l00352"></a>00352         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyManualBonesDirty(<span class="keywordtype">void</span>);
<a name="l00354"></a>00354         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyManualBoneStateChange(<a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* bone);
<a name="l00355"></a>00355 
<a name="l00357"></a><a class="code" href="classOgre_1_1Skeleton.html#abe8363fb958cb666ac2c12cb9cde844f">00357</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Skeleton.html#abe8363fb958cb666ac2c12cb9cde844f" title="Have manual bones been modified since the skeleton was last updated?">getManualBonesDirty</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mManualBonesDirty; }
<a name="l00359"></a><a class="code" href="classOgre_1_1Skeleton.html#ac9a9e603f2da6248b004f3f958a69664">00359</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Skeleton.html#ac9a9e603f2da6248b004f3f958a69664" title="Are there any manually controlled bones?">hasManualBones</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> !mManualBones.empty(); }
<a name="l00360"></a>00360 
<a name="l00362"></a><a class="code" href="classOgre_1_1Skeleton.html#a8abe9156a0ce2a08c9f60aa1de097796">00362</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;ushort&gt;::type</a> <a class="code" href="classOgre_1_1Skeleton.html#a8abe9156a0ce2a08c9f60aa1de097796" title="Map to translate bone handle from one skeleton to another skeleton.">BoneHandleMap</a>;
<a name="l00363"></a>00363 
<a name="l00397"></a>00397         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _mergeSkeletonAnimations(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* source,
<a name="l00398"></a>00398             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html#a8abe9156a0ce2a08c9f60aa1de097796" title="Map to translate bone handle from one skeleton to another skeleton.">BoneHandleMap</a>&amp; boneHandleMap,
<a name="l00399"></a>00399             <span class="keyword">const</span> <a class="code" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a>&amp; animations = <a class="code" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a>());
<a name="l00400"></a>00400 
<a name="l00405"></a>00405         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _buildMapBoneByHandle(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* source,
<a name="l00406"></a>00406             <a class="code" href="classOgre_1_1Skeleton.html#a8abe9156a0ce2a08c9f60aa1de097796" title="Map to translate bone handle from one skeleton to another skeleton.">BoneHandleMap</a>&amp; boneHandleMap) <span class="keyword">const</span>;
<a name="l00407"></a>00407 
<a name="l00412"></a>00412         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _buildMapBoneByName(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* source,
<a name="l00413"></a>00413             <a class="code" href="classOgre_1_1Skeleton.html#a8abe9156a0ce2a08c9f60aa1de097796" title="Map to translate bone handle from one skeleton to another skeleton.">BoneHandleMap</a>&amp; boneHandleMap) <span class="keyword">const</span>;
<a name="l00414"></a>00414 
<a name="l00415"></a>00415     <span class="keyword">protected</span>:
<a name="l00416"></a><a class="code" href="classOgre_1_1Skeleton.html#a20571d720d0f33cbc98adba63bec3b3d">00416</a>         <a class="code" href="group__Animation.html#ga230b218164ffe5e6ee8970bef57e6abd">SkeletonAnimationBlendMode</a> <a class="code" href="classOgre_1_1Skeleton.html#a20571d720d0f33cbc98adba63bec3b3d">mBlendState</a>;
<a name="l00418"></a><a class="code" href="classOgre_1_1Skeleton.html#a0164943c64c4d4634046c40eba6c6914">00418</a>         <a class="code" href="classOgre_1_1Skeleton.html#a7b773aab734f2f517897931dcb84a1e8">BoneList</a> <a class="code" href="classOgre_1_1Skeleton.html#a0164943c64c4d4634046c40eba6c6914" title="Storage of bones, indexed by bone handle.">mBoneList</a>;
<a name="l00420"></a><a class="code" href="classOgre_1_1Skeleton.html#a4b23538c9d0cdf6a59e0ab9852505811">00420</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, Bone*&gt;::type</a> <a class="code" href="classOgre_1_1Skeleton.html#a4b23538c9d0cdf6a59e0ab9852505811" title="Lookup by bone name.">BoneListByName</a>;
<a name="l00421"></a><a class="code" href="classOgre_1_1Skeleton.html#a51de68b26bf9a15ef399686713ac739b">00421</a>         <a class="code" href="classOgre_1_1Skeleton.html#a4b23538c9d0cdf6a59e0ab9852505811" title="Lookup by bone name.">BoneListByName</a> <a class="code" href="classOgre_1_1Skeleton.html#a51de68b26bf9a15ef399686713ac739b">mBoneListByName</a>;
<a name="l00422"></a>00422 
<a name="l00423"></a>00423 
<a name="l00425"></a><a class="code" href="classOgre_1_1Skeleton.html#a29e96975d05f528c597b93871088de8b">00425</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Skeleton.html#a7b773aab734f2f517897931dcb84a1e8">BoneList</a> <a class="code" href="classOgre_1_1Skeleton.html#a29e96975d05f528c597b93871088de8b" title="Pointer to root bones (can now have multiple roots)">mRootBones</a>;
<a name="l00427"></a><a class="code" href="classOgre_1_1Skeleton.html#a23e247a9b511eaa21e772d3ff3bb4b5f">00427</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1Skeleton.html#a23e247a9b511eaa21e772d3ff3bb4b5f" title="Bone automatic handles.">mNextAutoHandle</a>;
<a name="l00428"></a><a class="code" href="classOgre_1_1Skeleton.html#ab2a0ebba29e7b88dc30ae8b68973b7a6">00428</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1set.html">set&lt;Bone*&gt;::type</a> <a class="code" href="classOgre_1_1Skeleton.html#ab2a0ebba29e7b88dc30ae8b68973b7a6">BoneSet</a>;
<a name="l00430"></a><a class="code" href="classOgre_1_1Skeleton.html#a22374d7c595a7aacc812906b025d41f0">00430</a>         <a class="code" href="classOgre_1_1Skeleton.html#ab2a0ebba29e7b88dc30ae8b68973b7a6">BoneSet</a> <a class="code" href="classOgre_1_1Skeleton.html#a22374d7c595a7aacc812906b025d41f0" title="Manual bones.">mManualBones</a>;
<a name="l00432"></a><a class="code" href="classOgre_1_1Skeleton.html#aa41c36e353417b99d64c31fb8a39c3af">00432</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Skeleton.html#aa41c36e353417b99d64c31fb8a39c3af" title="Manual bones dirty?">mManualBonesDirty</a>;
<a name="l00433"></a>00433 
<a name="l00434"></a>00434 
<a name="l00436"></a><a class="code" href="classOgre_1_1Skeleton.html#a0da79ff61521994b338e4818822acf69">00436</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, Animation*&gt;::type</a> <a class="code" href="classOgre_1_1Skeleton.html#a0da79ff61521994b338e4818822acf69" title="Storage of animations, lookup by name.">AnimationList</a>;
<a name="l00437"></a><a class="code" href="classOgre_1_1Skeleton.html#ad9304a32da9742c346eb2c24dfeaef94">00437</a>         <a class="code" href="classOgre_1_1Skeleton.html#a0da79ff61521994b338e4818822acf69" title="Storage of animations, lookup by name.">AnimationList</a> <a class="code" href="classOgre_1_1Skeleton.html#ad9304a32da9742c346eb2c24dfeaef94">mAnimationsList</a>;
<a name="l00438"></a>00438 
<a name="l00440"></a><a class="code" href="classOgre_1_1Skeleton.html#ad714391a25cdf4eb435c269d882e7904">00440</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Skeleton.html#ac2559ddaccbf43ffc97330573c9561fd">LinkedSkeletonAnimSourceList</a> <a class="code" href="classOgre_1_1Skeleton.html#ad714391a25cdf4eb435c269d882e7904" title="List of references to other skeletons to use animations from.">mLinkedSkeletonAnimSourceList</a>;
<a name="l00441"></a>00441 
<a name="l00447"></a>00447         <span class="keywordtype">void</span> deriveRootBone(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00448"></a>00448 
<a name="l00450"></a>00450         <span class="keywordtype">void</span> _dumpContents(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename);
<a name="l00451"></a>00451 
<a name="l00454"></a>00454         <span class="keywordtype">void</span> loadImpl(<span class="keywordtype">void</span>);
<a name="l00455"></a>00455 
<a name="l00458"></a>00458         <span class="keywordtype">void</span> unloadImpl(<span class="keywordtype">void</span>);
<a name="l00460"></a><a class="code" href="classOgre_1_1Skeleton.html#afa83f6f72123b2e69ca5e96951934209">00460</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Skeleton.html#afa83f6f72123b2e69ca5e96951934209">calculateSize</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; } <span class="comment">// TODO </span>
<a name="l00461"></a>00461 
<a name="l00462"></a>00462     };
<a name="l00463"></a>00463 
<a name="l00470"></a><a class="code" href="classOgre_1_1SkeletonPtr.html">00470</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;Skeleton&gt; 
<a name="l00471"></a>00471     {
<a name="l00472"></a>00472     <span class="keyword">public</span>:
<a name="l00473"></a><a class="code" href="classOgre_1_1SkeletonPtr.html#a74423f10c7e83538c3f5463db84bd3fb">00473</a>         <a class="code" href="classOgre_1_1SkeletonPtr.html#a74423f10c7e83538c3f5463db84bd3fb">SkeletonPtr</a>() : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>&gt;() {}
<a name="l00474"></a><a class="code" href="classOgre_1_1SkeletonPtr.html#aa8fa63c93390b57f1e2abc2caf8647b2">00474</a>         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1SkeletonPtr.html#aa8fa63c93390b57f1e2abc2caf8647b2">SkeletonPtr</a>(<a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* rep) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>&gt;(rep) {}
<a name="l00475"></a><a class="code" href="classOgre_1_1SkeletonPtr.html#af3243f7eae18ed75d6d0ca6484a13a4d">00475</a>         <a class="code" href="classOgre_1_1SkeletonPtr.html#af3243f7eae18ed75d6d0ca6484a13a4d">SkeletonPtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>&gt;(r) {} 
<a name="l00476"></a><a class="code" href="classOgre_1_1SkeletonPtr.html#a6658dde5b31d0bbf51c7b1af9e1b58c3">00476</a>         <a class="code" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>&gt;()
<a name="l00477"></a>00477         {
<a name="l00478"></a>00478             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00479"></a>00479             <a class="code" href="OgrePrerequisites_8h.html#a2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00480"></a>00480             {
<a name="l00481"></a>00481                 <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00482"></a>00482                 <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00483"></a>00483                 pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00484"></a>00484                 pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00485"></a>00485                 <span class="keywordflow">if</span> (pUseCount)
<a name="l00486"></a>00486                 {
<a name="l00487"></a>00487                     ++(*pUseCount);
<a name="l00488"></a>00488                 }
<a name="l00489"></a>00489             }
<a name="l00490"></a>00490         }
<a name="l00491"></a>00491 
<a name="l00493"></a><a class="code" href="classOgre_1_1SkeletonPtr.html#a08db394bd29df84c7e3f1f2977c17395">00493</a>         <a class="code" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r)
<a name="l00494"></a>00494         {
<a name="l00495"></a>00495             <span class="keywordflow">if</span> (pRep == static_cast&lt;Skeleton*&gt;(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>()))
<a name="l00496"></a>00496                 <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00497"></a>00497             release();
<a name="l00498"></a>00498             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00499"></a>00499             <a class="code" href="OgrePrerequisites_8h.html#a2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00500"></a>00500             {
<a name="l00501"></a>00501                 <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00502"></a>00502                 <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00503"></a>00503                 pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00504"></a>00504                 pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00505"></a>00505                 <span class="keywordflow">if</span> (pUseCount)
<a name="l00506"></a>00506                 {
<a name="l00507"></a>00507                     ++(*pUseCount);
<a name="l00508"></a>00508                 }
<a name="l00509"></a>00509             }
<a name="l00510"></a>00510             <span class="keywordflow">else</span>
<a name="l00511"></a>00511             {
<a name="l00512"></a>00512                 <span class="comment">// RHS must be a null pointer</span>
<a name="l00513"></a>00513                 assert(r.<a class="code" href="classOgre_1_1SharedPtr.html#a8a223db784efd7aa766792649de2f2a0">isNull</a>() &amp;&amp; <span class="stringliteral">&quot;RHS must be null if it has no mutex!&quot;</span>);
<a name="l00514"></a>00514                 setNull();
<a name="l00515"></a>00515             }
<a name="l00516"></a>00516             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00517"></a>00517         }
<a name="l00518"></a>00518     };
<a name="l00519"></a>00519 
<a name="l00521"></a><a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html">00521</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html" title="Link to another skeleton to share animations.">LinkedSkeletonAnimationSource</a>
<a name="l00522"></a>00522     {
<a name="l00523"></a><a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#a18367921f5c2e7eddaf14a54dacd3484">00523</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#a18367921f5c2e7eddaf14a54dacd3484">skeletonName</a>;
<a name="l00524"></a><a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#a02c73a85564ec0047f8de9b71e771331">00524</a>         <a class="code" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a> <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#a02c73a85564ec0047f8de9b71e771331">pSkeleton</a>;
<a name="l00525"></a><a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#a79bb4debcd21595087623b9a8d17d121">00525</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#a79bb4debcd21595087623b9a8d17d121">scale</a>;
<a name="l00526"></a><a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#a7a01cb43456b193136f19dd60e9ec7f2">00526</a>         <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#a7a01cb43456b193136f19dd60e9ec7f2">LinkedSkeletonAnimationSource</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; skelName, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scl)
<a name="l00527"></a>00527             : <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#a18367921f5c2e7eddaf14a54dacd3484">skeletonName</a>(skelName), <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#a79bb4debcd21595087623b9a8d17d121">scale</a>(scl) {}
<a name="l00528"></a><a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#ad04b9f46242d6c0f8226f423274a3c40">00528</a>             <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#a7a01cb43456b193136f19dd60e9ec7f2">LinkedSkeletonAnimationSource</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; skelName, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scl, 
<a name="l00529"></a>00529                 <a class="code" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a> skelPtr)
<a name="l00530"></a>00530                 : <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#a18367921f5c2e7eddaf14a54dacd3484">skeletonName</a>(skelName), <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#a02c73a85564ec0047f8de9b71e771331">pSkeleton</a>(skelPtr), <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#a79bb4debcd21595087623b9a8d17d121">scale</a>(scl) {}
<a name="l00531"></a>00531     };
<a name="l00535"></a>00535 }
<a name="l00536"></a>00536 
<a name="l00537"></a>00537 
<a name="l00538"></a>00538 <span class="preprocessor">#endif</span>
<a name="l00539"></a>00539 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
